diff --git a/devel/libc++/Makefile b/devel/libc++/Makefile
index d571309781d..ad21d1e87b1 100644
--- a/devel/libc++/Makefile
+++ b/devel/libc++/Makefile
@@ -2,10 +2,10 @@
 # $FreeBSD$
 
 PORTNAME?=	libc++
-DISTNAME=	libc++-${PORTVERSION}
-PORTVERSION=	6.0.1
+DISTNAME=	libcxx-${PORTVERSION}.src
+PORTVERSION=	8.0.0
 CATEGORIES=	devel
-MASTER_SITES=	https://avalon.dragonflybsd.org/misc/distfiles/ \
+MASTER_SITES=	http://releases.llvm.org/${PORTVERSION}/
 
 MAINTAINER=	tuxillo@quantumachine.net
 COMMENT?=	LLVM C++ standard library with c++11 support
@@ -29,7 +29,6 @@ LIB_DEPENDS+=	libcxxrt.so:devel/libcxxrt
 
 CMAKE_ARGS=	-DLIBCXX_CXX_ABI=libcxxrt -DLIBCXX_CXX_ABI_INCLUDE_PATHS=${CXXRT_INCS}
 
-
 post-install:
 	${LN} -sf c++/v1 ${STAGEDIR}${PREFIX}/include/c++/v1/tr1
 	${RM} ${STAGEDIR}${PREFIX}/lib/libc++.so
@@ -37,8 +36,5 @@ post-install:
 	${ECHO} 'GROUP ( ${PREFIX}/lib/libc++.so.1 ${CXXRT_LIB} ${EXTRALIB})' > ${STAGEDIR}${PREFIX}/lib/libc++.so
 	${ECHO} 'GROUP ( ${PREFIX}/lib/libc++.so.1 ${CXXRT_LIB} ${EXTRALIB})' > ${STAGEDIR}${PREFIX}/lib/c++/libstdc++.so
 
-regression-test: build
-	cd ${WRKSRC}/test && ${SH} ./testit
-
 .endif
 .include <bsd.port.mk>
diff --git a/devel/libc++/distinfo b/devel/libc++/distinfo
index 28ece8e7b85..119b6153910 100644
--- a/devel/libc++/distinfo
+++ b/devel/libc++/distinfo
@@ -1,3 +1,3 @@
-TIMESTAMP = 1534892547
-SHA256 (libc++-6.0.1.tar.xz) = 9cdd1c1430f4822a3745f6a28383d65567cfcf8107ce4f6c83cc85f7b44b17b0
-SIZE (libc++-6.0.1.tar.xz) = 1560280
+TIMESTAMP = 1553383583
+SHA256 (libcxx-8.0.0.src.tar.xz) = c2902675e7c84324fb2c1e45489220f250ede016cc3117186785d9dc291f9de2
+SIZE (libcxx-8.0.0.src.tar.xz) = 1752308
diff --git a/devel/libc++/files/patch-include_stddef.h b/devel/libc++/files/patch-include_stddef.h
index 23cd22107c4..637d407842d 100644
--- a/devel/libc++/files/patch-include_stddef.h
+++ b/devel/libc++/files/patch-include_stddef.h
@@ -1,11 +1,11 @@
---- include/stddef.h.orig	2017-02-10 01:27:42 UTC
+--- include/stddef.h.orig	2018-08-20 22:29:20 UTC
 +++ include/stddef.h
 @@ -54,7 +54,7 @@ using std::nullptr_t;
  
  // Re-use the compiler's <stddef.h> max_align_t where possible.
  #if !defined(__CLANG_MAX_ALIGN_T_DEFINED) && !defined(_GCC_MAX_ALIGN_T) && \
--    !defined(__DEFINED_max_align_t)
-+  !defined(__DEFINED_max_align_t) && !defined(_MAX_ALIGN_T_DECLARED)
+-    !defined(__DEFINED_max_align_t) && !defined(__NetBSD__)
++    !defined(__DEFINED_max_align_t) && !defined(__NetBSD__) && !defined(_MAX_ALIGN_T_DECLARED)
  typedef long double max_align_t;
  #endif
  
diff --git a/devel/libc++/pkg-plist b/devel/libc++/pkg-plist
index db630349345..048d38c8a92 100644
--- a/devel/libc++/pkg-plist
+++ b/devel/libc++/pkg-plist
@@ -3,6 +3,7 @@ include/c++/v1/__bsd_locale_defaults.h
 include/c++/v1/__bsd_locale_fallbacks.h
 include/c++/v1/__config
 include/c++/v1/__debug
+include/c++/v1/__errc
 include/c++/v1/__functional_03
 include/c++/v1/__functional_base
 include/c++/v1/__functional_base_03
@@ -10,6 +11,7 @@ include/c++/v1/__hash_table
 include/c++/v1/__libcpp_version
 include/c++/v1/__locale
 include/c++/v1/__mutex_base
+include/c++/v1/__node_handle
 include/c++/v1/__nullptr
 include/c++/v1/__split_buffer
 include/c++/v1/__sso_allocator
@@ -23,6 +25,7 @@ include/c++/v1/algorithm
 include/c++/v1/any
 include/c++/v1/array
 include/c++/v1/atomic
+include/c++/v1/bit
 include/c++/v1/bitset
 include/c++/v1/cassert
 include/c++/v1/ccomplex
@@ -30,6 +33,7 @@ include/c++/v1/cctype
 include/c++/v1/cerrno
 include/c++/v1/cfenv
 include/c++/v1/cfloat
+include/c++/v1/charconv
 include/c++/v1/chrono
 include/c++/v1/cinttypes
 include/c++/v1/ciso646
@@ -66,7 +70,6 @@ include/c++/v1/experimental/any
 include/c++/v1/experimental/chrono
 include/c++/v1/experimental/coroutine
 include/c++/v1/experimental/deque
-include/c++/v1/experimental/dynarray
 include/c++/v1/experimental/filesystem
 include/c++/v1/experimental/forward_list
 include/c++/v1/experimental/functional
@@ -93,6 +96,7 @@ include/c++/v1/experimental/vector
 include/c++/v1/ext/__hash
 include/c++/v1/ext/hash_map
 include/c++/v1/ext/hash_set
+include/c++/v1/filesystem
 include/c++/v1/float.h
 include/c++/v1/forward_list
 include/c++/v1/fstream
@@ -128,6 +132,7 @@ include/c++/v1/scoped_allocator
 include/c++/v1/set
 include/c++/v1/setjmp.h
 include/c++/v1/shared_mutex
+include/c++/v1/span
 include/c++/v1/sstream
 include/c++/v1/stack
 include/c++/v1/stdbool.h
@@ -184,3 +189,4 @@ lib/libc++.so
 lib/libc++.so.1
 lib/libc++.so.1.0
 lib/libc++experimental.a
+lib/libc++fs.a